#include "stdafx.h"
#include "plrint.h"

bool pat_set(int num) {
	if (num >= pmdmdl->pat_num) return true;

	player.pattern.pos = 0;
	player.pattern.num = num;

	pt3md_pattern *rawpat = (pt3md_pattern*)&player.pattab[player.pattern.num*(sizeof(pt3md_pattern_pchan) + sizeof(pt3md_pattern)) + sizeof(pt3md_pattern_pchan)];
	pt3md_pattern_pchan *rawpchan = (pt3md_pattern_pchan*)&player.pattab[player.pattern.num*(sizeof(pt3md_pattern_pchan) + sizeof(pt3md_pattern))];

	player.pattern.dat = rawpat;

	for (int i = 0; i < 4; i++) {
		player.chan[i].isskip = false;
		player.chan[i].skip   = player.chan[i].skippos = 1;

		player.chan[i].pchan  = &pmdstream[rawpchan->p_chan[i]];
	}

	// process 0th line
	pat_process();

	return false;
}

void pat_process() {
#if 0
	// STUB!
	_module_end = true; return;
#endif
	if (player.pattern.pos >= player.pattern.dat->patlen) {
		player.pattern.ordpos++;
		if (player.pattern.ordpos >= pmdmdl->ord_num) {
			_module_end = true;
			return;
		}
		pat_set(player.ordtab[player.pattern.ordpos]); return;
	}

	// set speed counter
	player.spdpos = player.speed;

	// parse pattern
	struct {
		struct chan_t {
			pmd_chan_event_NN nn;
			pmd_chan_event_XV xv;
			pmd_chan_event_II ii;
			pmd_chan_event_OO oo;
			pmd_chan_event_DC dc;
			pmd_chan_event_EE ee;
		} chan[3];
		pmd_env_event_XT xt;
		pmd_env_event_PP pp;
		pmd_env_event_OO oo;
		pmd_env_event_NN nn;
		pmd_env_event_DC dc;
		pmd_env_event_EE ee;
	} pmdevent;

	// parse a->b->c chans
	for (int i = 0; i < 3; i++) {
		if ((player.chan[i].isskip) && (--player.chan[i].skippos)) continue; else player.chan[i].isskip = false;
		
		// parse prefix
		bool skip = false, prefix = true;
		do {
			pmdevent.chan[i].nn.val = (u8)*player.chan[i].pchan++;
			switch (pmdevent.chan[i].nn.val) {
			case 0x7F:
				// skip this and next lines
				player.chan[i].isskip = true;
				player.chan[i].skippos = *player.chan[i].pchan++;
				prefix = false; skip = true;
				continue;

			case 0xE8:
				// disable envelope
				chan[i].env = 0;
				break;

			case 0xEC:
				// enable envelope
				chan[i].env = 1;
				break;
	
			default:
				if ((pmdevent.chan[i].nn.val >= 0xF0) && (pmdevent.chan[i].nn.val <= 0xFF)) {
					// set volume
					chan[i].volume_ch = pmdevent.chan[i].nn.val - 0xF0;
				} else {
					// parse as note
					prefix = false;
					player.chan[i].pchan--;	// trick
				}
				break;
			}
		} while (prefix);

		if (skip) continue;

		bool newnote = false;

		// parse note
		pmdevent.chan[i].nn.val = (u8)*player.chan[i].pchan++;
		switch (pmdevent.chan[i].nn.note) {
		case 0x0:
			// no note - continue playing current
			break;

		case pmd_chan_event_NN_note::notecut:
			// note cut (aka R-- in pt3)
			chan[i].cut = true;
			break;

		case pmd_chan_event_NN_note::noteoff:
			// note off
			chan[i].ins.sustain = false;
			break;

		default:
			// valid note
			newnote = true;
			chan[i].cut = chan[i].off = false;
			chan[i].oldnote = chan[i].basenote;
			chan[i].basenote = pmdevent.chan[i].nn.note - 1; // !

			ins_set(i, chan[i].ins.num, 0);	// reset instrument
			orn_set(i, chan[i].orn.num, 0);	// reset ornament
			cmd_set(i, 1, 0, 0);			// stop all slides
			chan[i].cmd.slide.acc = 0;		// and flush slide accumulator
			cmd_set(i, 6, 0, 0);			// stop tremor

			break;
		}

		// jump to next channel if last element in event 
		if (!pmdevent.chan[i].nn.notlast) continue;

		// parse volume/flags (ugly typecast hack)
		*(u8*)&pmdevent.chan[i].xv = (u8)*player.chan[i].pchan++;

		// set new volume/env
		chan[i].volume_ch ^= pmdevent.chan[i].xv.vol;
		chan[i].env       ^= pmdevent.chan[i].xv.env;

		// some temp vars
		unsigned long newins = -1, inspos = 0, neworn = -1, ornpos = 0;

		// parse new ins/orn
		if (pmdevent.chan[i].xv.ins) {
			newins = pmdevent.chan[i].ii = (u8)*player.chan[i].pchan++;
			if (newnote) ins_set(i, newins, 0);
		}
		if (pmdevent.chan[i].xv.orn) {
			neworn = pmdevent.chan[i].oo = (u8)*player.chan[i].pchan++;
			orn_set(i, neworn, 0);
		}

		// parse commands
		if (pmdevent.chan[i].xv.cmd) {
			*(u8*)&pmdevent.chan[i].dc = (u8)*player.chan[i].pchan++;
			if (!pmdevent.chan[i].dc.cmd) break;

			// extract additional stuff or not
			switch(pmdevent.chan[i].dc.cmd) {
			case 0x1:
			case 0x2:
			case 0x3:
			case 0x8:
			case 0xA:
				// (subparm == 0) - no ee
				pmdevent.chan[i].ee = (pmdevent.chan[i].dc.subparm == 0 ? 0 : (u8)*player.chan[i].pchan++);
				break;

			case 0x7:
				// ignore ee
				pmdevent.chan[i].ee = 0;
				break;

			default:
				// ee is always present
				pmdevent.chan[i].ee = (u8)*player.chan[i].pchan++;
				break;
			}
			cmd_set(i, pmdevent.chan[i].dc.cmd, pmdevent.chan[i].dc.subparm, pmdevent.chan[i].ee);
		}
	}


	// parse envelope\noise channel
	env_chan.env.restart = false;
	
	{
		if ((player.chan[3].isskip) && (--player.chan[3].skippos)) goto __end; else player.chan[3].isskip = false;

		// parse envtype\flags
		pmdevent.xt.val = (u8)*player.chan[3].pchan++;
		if (pmdevent.xt.val == 0x7) {
			// skip this and next lines
			player.chan[3].isskip = true;
			player.chan[3].skippos = *player.chan[3].pchan++;
			goto __end;					// ffffffuuuuuuuuuuuuuuuu!
		}

		if (pmdevent.xt.restart) {
			env_chan.env.restart = true;
			env_chan.env.type	 = pmdevent.xt.type | 0x8;
			chan[3].cmd.slide.active = chan[3].cmd.tremor.active = false;
			chan[3].cmd.slide.acc = 0;
		}

		// parse period set
		switch(pmdevent.xt.fmt) {
		case pmd_env_event_XT_fmt::period_lsb:
			// pp - env period lsb
			pmdevent.pp.period_lsb = (u8)*player.chan[3].pchan++;
			env_chan.env.base = pmdevent.pp.period_lsb;
			chan[3].cmd.slide.active = chan[3].cmd.tremor.active = false;
			chan[3].cmd.slide.acc = 0;
			break;

		case pmd_env_event_XT_fmt::period:
			// oo pp - env period
			pmdevent.pp.period_lsb = (u8)*player.chan[3].pchan++;
			pmdevent.oo			   = (u8)*player.chan[3].pchan++;
			env_chan.env.base = (pmdevent.pp.period_lsb) | (pmdevent.oo << 8);
			chan[3].cmd.slide.active = chan[3].cmd.tremor.active = false;
			chan[3].cmd.slide.acc = 0;
			break;

		default:
			// note is unsupported
			break;
		}

		// parse noise
		if (pmdevent.xt.noise) env_chan.noise.base = pmdevent.nn = (u8)*player.chan[3].pchan++; 

		// no cmds this time ( !     %)
		// parse commands
		if (pmdevent.xt.cmd) {
			*(u8*)&pmdevent.dc = (u8)*player.chan[3].pchan++;
			if (!pmdevent.dc.cmd) goto __end;

			// extract additional stuff or not
			switch(pmdevent.dc.cmd) {
			case 0x1:
			case 0x2:
			case 0x3:
				// (subparm == 0) - no ee
				pmdevent.ee = (pmdevent.dc.subparm == 0 ? 0 : (u8)*player.chan[3].pchan++);
				break;

			default:
				// ee is always present
				pmdevent.ee = (u8)*player.chan[3].pchan++;
				break;
			}
			cmd_set(3, pmdevent.dc.cmd, pmdevent.dc.subparm, pmdevent.ee);
		}
	}

	__end:
	//        
	player.pattern.pos++;

}